Subject: Re: bug#5040: 23.1; w32-register-hot-key problem

From: Juanma Barranquero <[email-masked]>
Date: Sat, 2 Jul 2011 19:23:47 +0200

On Sat, Jul 2, 2011 at 16:16, Drew Adams <[email-masked]> wrote:

> Correction: it works with 20 and 21, not with 22 or 23 (or 24).

Yes, sorry.

> Why not at least look into why this
> might be?
>
> Emacs apparently *knows* how to make this work - it works forever after the
> first M-TAB, and in Emacs 20 and 21 it works even for the first M-TAB.  It's not
> like this is something Emacs doesn't know how to do correctly - it's that a bug
> was introduced to break it.

Or perhaps it worked right before just by happenstance. Perhaps we
were passing uninitialized data to some API, and the moment we fixed
it it stopped working. On Windows 7, I cannot make it work *at all*,
not the first time, not afterwards, not ever.

> That MS Windows "reserves" something is not in itself (i.e., alone) a reason
> that Emacs should respect that "reservation".  There is nothing new about MS
> Windows using M-TAB, and nothing new about Emacs using M-TAB.
>
> And to use it in Emacs, Windows users must explicitly do (w32-register-hot-key
> [M-tab]).  That's a user choice, not Emacs's choice or Windows's choice.
>
> The bug remains.  And AFAICT no one has even looked at it (why does it happen?
> what change introduced the bug?).  There has only been argument over whether
> Windows officially permits Emacs to do something it has always done.  There is
> nothing in this bug thread apart from the bug report recipe and frothing about
> how Emacs shouldn't disrespect Windows's "reservation".

> Why the zeal to "close" bugs that remain bugs?  This bug has never even been
> investigated.  If there is insufficient manpower to look into this bug, then
> leave it open.

There are very few maintainers of Emacs for Windows. No one of us has
shown any inclination to fix it or give it too much weight, and even
if you believe that Emacs is not bound to obey Microsoft, it is
certainly easier to go with the flow that against it, and the flow is
for that kind of keystrokes to be more strongly reserved for Windows
functions, not less.

It *was* a regression, on 2007-06-02 when 22.1 was released. Now, four
years later, it seems like something which is not worth investing any
effort in fixing it (specially because, as I've said, I think it
wouldn't easily work at all on newer Windows). Of course that's my
take, and that's why I closed the bug. If you feel strongly, don't
hesitate to reopen it and change it to a Wontfix, because I suspect no
one is going to go the trouble to fix it anyway (though I could be
wrong).

    Juanma